/**** Fichier principal pour le pont virtuel ****/

/** Fichiers d'inclusion **/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <poll.h>
#include "libnet.h"
/** Quelques constantes **/

/** Variables globales **/

/** Fonctions **/

int traitement (int s)
{	
	printf("Nouveau client connecté !\n");
	FILE *dialogue=fdopen(s,"a+");
	if(dialogue==NULL){ perror("gestionClient.fdopen"); exit(EXIT_FAILURE); }

	float val_x,val_y,val_z;
	int run = 1;

	while(run)
	{
		read/*_fixed*/(s,&val_x,sizeof(val_x));
		read/*_fixed*/(s,&val_y,sizeof(val_y));
		read/*_fixed*/(s,&val_z,sizeof(val_z));
	
		#ifdef DEBUG
		fprintf(stdout,"(R) : val_x = %0.3f / val_y = %0.3f / val_z = %0.3f\n",val_x,val_y,val_z);
		#endif
		
		if((val_x > 400) && (val_y > 400) && (val_z > 400))
		{
			printf("Client déconnecté !\n");
			run = 0;
		}
	
		sleep(1);
	}

	fclose(dialogue);
	return 0;
}


/* Fonction principale */
int main(int argc,char *argv[])
{
	// Analyse des arguments
	if(argc!=2){
	fprintf(stderr,"Syntaxe : bridge <port>\n");
	exit(-1);}
	
	char *port=argv[1];
	#ifdef DEBUG
	fprintf(stdout,"Port : %s\n",port);
	#endif

	// Initialisation du serveur
	int s = initialisationServeur(port,1);
	if (s<0){perror("initialisationServeur.socket");
	exit(EXIT_FAILURE);}
	
	// Traitement des connexions et des messages
	boucleServeur(s,traitement);

	char *nom = "tap0";
	int var = creationInterfaceVirtuelle(nom) ;

	/* Boucle de communication avec le serveur */
	struct pollfd descripteurs[2];
	descripteurs[0].fd=s;
	descripteurs[0].events=POLLIN;
	descripteurs[1].fd=var;
	descripteurs[1].events=POLLIN;

	while(1)
	{
		unsigned char tampon[MAX_TAMPON];
		int nb=poll(descripteurs,2,-1);
		if(nb<0){ perror("main.poll"); exit(EXIT_FAILURE); }
		if((descripteurs[0].revents&POLLIN)!=0)
		{
			unsigned char taille;
			read_fixed(s,&taille,sizeof taille);
			read_fixed(s,tampon,taille);
			write(var,tampon,taille);
		}
		if((descripteurs[1].revents&POLLIN)!=0)
		{
			int taille=read(var,tampon,MAX_TAMPON);
			if(taille<=0) break;
			write(s,&taille,sizeof taille);    
			write(s,tampon,taille);
		}
		fprintf(stdout,"revents = %d\n",descripteurs[1].revents);
	}

	/* On termine la connexion */
	shutdown(s,SHUT_RDWR);

	return 0;
}
